--- lib/command.h.orig	Fri Jun  2 00:35:00 2000
+++ lib/command.h	Sun Jul 16 22:25:17 2000
@@ -97,6 +97,7 @@
   COMMUNITY_LIST_NODE,		/* Community list node. */
   RMAP_NODE,			/* Route map node. */
   DUMP_NODE,			/* Packet dump node. */
+  PIM_NODE,			/* Pim node. */
   VTY_NODE			/* Vty node. */
 };
 
--- lib/command.c.orig	Mon Jun 12 05:33:33 2000
+++ lib/command.c	Sun Jul 16 22:25:17 2000
@@ -1978,6 +1978,7 @@
     case OSPF6_NODE:
     case MASC_NODE:
     case RMAP_NODE:
+    case PIM_NODE:
     case VTY_NODE:
       vty->node = CONFIG_NODE;
       break;
--- lib/memory.h.orig	Tue Jun  6 05:41:32 2000
+++ lib/memory.h	Fri Aug 11 13:03:22 2000
@@ -135,6 +135,14 @@
   MTYPE_BGP_STATIC,
   MTYPE_BGP_AGGREGATE,
   MTYPE_BGP_CONFED_LIST,
+  MTYPE_PIM_FIFO,
+  MTYPE_PIM_IF,
+  MTYPE_PIM_NEIGHBOR,
+  MTYPE_PIM_OIF,
+  MTYPE_PIM_SG,
+  MTYPE_PIM_G,
+  MTYPE_PIM_SRC,
+  MTYPE_IGMP_OIF,
   MTYPE_MAX
 };
 
--- lib/memory.c.orig	Wed May 31 14:32:21 2000
+++ lib/memory.c	Fri Aug 11 12:46:33 2000
@@ -308,6 +308,18 @@
   { -1, NULL },
 };
 
+struct memory_list memory_list_pim[] =
+{
+  { MTYPE_PIM_FIFO,           "PIM FIFO queue : %ld\r\n" },
+  { MTYPE_PIM_IF,             "PIM interface  : %ld\r\n" },
+  { MTYPE_PIM_OIF,            "PIM OIF        : %ld\r\n" },
+  { MTYPE_PIM_SG,             "PIM (S,G)      : %ld\r\n" },
+  { MTYPE_PIM_G,              "PIM/IGMP (*,G) : %ld\r\n" },
+  { MTYPE_PIM_SRC,            "Multicast src  : %ld\r\n" },
+  { MTYPE_PIM_NEIGHBOR,       "PIM neighbor   : %ld\r\n" },
+  { -1, NULL },
+};
+
 struct memory_list memory_list_separator[] =
 {
   { 0,                        "---------------------\r\n" },
@@ -340,6 +352,7 @@
   show_memory_vty (vty, memory_list_ospf);
   show_memory_vty (vty, memory_list_separator);
   show_memory_vty (vty, memory_list_bgp);
+  show_memory_vty (vty, memory_list_pim);
 
   return CMD_SUCCESS;
 }
@@ -394,6 +407,17 @@
   return CMD_SUCCESS;
 }
 
+DEFUN (show_memory_pim,
+       show_memory_pim_cmd,
+       "show memory pim",
+       SHOW_STR
+       "Memory statistics\n"
+       "PIM memory\n")
+{
+  show_memory_vty (vty, memory_list_pim);
+  return CMD_SUCCESS;
+}
+
 void
 memory_init ()
 {
@@ -403,6 +427,7 @@
   install_element (VIEW_NODE, &show_memory_rip_cmd);
   install_element (VIEW_NODE, &show_memory_bgp_cmd);
   install_element (VIEW_NODE, &show_memory_ospf_cmd);
+  install_element (VIEW_NODE, &show_memory_pim_cmd);
 
   install_element (ENABLE_NODE, &show_memory_cmd);
   install_element (ENABLE_NODE, &show_memory_all_cmd);
@@ -410,4 +435,5 @@
   install_element (ENABLE_NODE, &show_memory_rip_cmd);
   install_element (ENABLE_NODE, &show_memory_bgp_cmd);
   install_element (ENABLE_NODE, &show_memory_ospf_cmd);
+  install_element (ENABLE_NODE, &show_memory_pim_cmd);
 }
--- lib/log.h.orig	Fri Mar 24 00:20:31 2000
+++ lib/log.h	Sun Jul 16 22:25:17 2000
@@ -40,6 +40,7 @@
   ZLOG_OSPF,
   ZLOG_RIPNG,  
   ZLOG_OSPF6,
+  ZLOG_PIM,	
   ZLOG_MASC
 } zlog_proto_t;
 
